import math

""" in these [a, b, c, d] =
	[a, b,
	 c, d]
"""

def eigs(A):
	[a, b, c, d] = A # known symmetric
	t = a+d
	d = a*d-b*c
	e0 = (t + math.sqrt(t*t - 4*d))/2.0
	e1 = d/e0
	# (a-e0)x0 + b y0 = 0
	x0 = -b; y0 = a-e0
	x1 = d-e1; y1 = -c
	r0 = math.sqrt(x0*x0+y0*y0)
	r1 = math.sqrt(x1*x1+y1*y1)
	if r0 == 0:
		[x0, y0] = [1, 0]
	else:
		x0 /= r0
		y0 /= r0
	""" if r1 == 0:
		[x1, y1] = [0, 1]
	else:
		x1 /= r1
		y1 /= r1 """
	x1 = -y0
	y1 =  x0
	answer = [ [e0, x0, y0], [e1, x1, y1]]
	"""
	print [a*x0+b*y0 - e0*x0, c*x0+d*y0-e0*y0]
	print [a*x1+b*y1 - e1*x1, c*x1+d*y1-e1*y1]
	"""
	return answer

"""
	[a b][x y]
	[c d][z w]
"""

def mul(A, B):
	[a, b, c, d] = A
	[x, y, z, w] = B
	return [a*x+b*z, a*y+b*w, c*x+d*z, c*y+d*w]

"""
	[a, b, 
	 c, d] = A
	[a, c,
	 b, d] = A^t

"""
# A = k1 a k2
def kak(A):
	[a, b, c, d] = A
	# A.A^t
	B = [a*a+b*b, a*c+b*d, a*c+b*d, c*c+d*d ]
	E = eigs(B)
	[e0, x0, y0] = E[0]
	[e1, x1, y1] = E[1]
	a0 = math.sqrt(e0)
	a1 = math.sqrt(e1)
	K = [x0, x1, y0, y1]
	Kt = [x0, y0, x1, y1]
	# L = K^t A
	B = [a0, 0, 0, a1]
	L = mul([1.0/a0, 0, 0, 1.0/a1], mul(Kt, A))
	""" 
	print "A =", A, "?"
	print "[", 
	for x in mul(K, mul(B, L)):
		print cstr(x),
	print "]", 
	"""
	return [K, B, L]

# ----------------------------------------------------------

"""
print kak([1, 1, 0, 1])
"""
	
