

from Fstr import fstr
from Vectors import Vector

# a Matrix is a column of row Vectors

class Matrix:

	def __init__(self, *args):
		r = len(args)
		if len(args) == 1:
			a = args[0]
			r = len(a)
		else:
			a = args
		M = []
		for i in range(r):
			M.append(Vector(a[i]))
		self.m = M
			
	def __getitem__(self, i):
		return self.m[i]

	def clone(self):
		g = self.m
		r = len(g)
		c = len(g[0])
		m = []
		for i in range(r):
			row = []
			for j in range(c):
				row.append(g[i][j])
			m.append(Vector(row))
		return Matrix(m)
	
	def transform(self, v):
		m = self.m
		r = len(m); c = len(v)
		p = []
		for i in range(r):
			s = 0
			for j in range(c):
				s += m[i][j]*v[j]
			p.append(s)
		return(Vector(p))
	
	

	# dot product, matrix product, matrix x vector 
	def __mul__(self, v):
		u = self.m
		r = len(u); c = len(v[0])
		p = []
		for i in range(r):
			q = []
			for k in range(c):
				s = 0
				for j in range(len(u[0])):
					s += u[i][j]*v[j][k]
				q.append(s)
			p.append(q)
		return Matrix(p)

	def transpose(self):
		m = self.m
		M = []
		# M[j][i] = m[i][j]
		for j in range(len(m[0])):
			r = []
			for i in range(len(m)):
				r.append(m[i][j])
			M.append(r)
		return Matrix(M)
		
	def __str__(self):
		s = "["
		m = self.m
		r = len(m)
		for i in range(r):
			s += str(m[i]) + "\n"
		s += "]"
		return(s)
		
# -------------------------------------

"""

a = Matrix([1,1],[0,1])
b = Matrix([[1,2],[0,1]])
c = a*b
print c.m[0]
print c.m[1]

"""



