# -----------------------------------------------------------------------

# converts byte arrays to integers according to Knuth's conventions
class knuth:
	# in = a binary file
	# Returns a signed int of k bytes

	def getInt(input, k):
		# reads k bytes as signed int
		n = 0
		ell = ((4-k) << 3)
		for i in range(k):
			m = (ord)(input.read(1))
			# handle exceptions?
			n = (n << 8) + m
		if (n >= 1 << (k*8-1)):
			# print "- " + str(n)
			n = n - (1 << k*8)
		return(n)
	getInt = staticmethod(getInt)

	def getUnsigned(input, k):
		# print "k = ", k
		# reads k bytes as unsigned, unless k = 4
		n = 0
		for i in range(k):
			m = (ord)(input.read(1))
			n = (n << 8) + m
		return(n)	# get unsigned int from 4 bytes
	getUnsigned = staticmethod(getUnsigned)

	def getWord(input):
		n = (ord)(input.read(1))
		m = (ord)(input.read(1))
		n = (n << 8) + m
		m = (ord)(input.read(1))
		n = (n << 8) + m
		m = (ord)(input.read(1))
		n = (n << 8) + m
		return(n)
	getWord = staticmethod(getWord)

	def getString(input, n):
		s = ""
		for i in range(n):
			s += (chr)((ord)(input.read(1)))
		return(s)
	getString = staticmethod(getString)

