import math

def clone(g):
	r = len(g)
	c = len(g[0])
	m = []
	for i in range(r):
		row = []
		for j in range(c):
			row.append(g[i][j])
		m.append(row)
	return m

def mul(u, v):
	r = len(u); c = len(v[0])
	p = []
	for i in range(r):
		q = []
		for k in range(c):
			s = 0
			for j in range(len(u[0])):
				s += u[i][j]*v[j][k]
			q.append(s)
		p.append(q)
	return(p)

def transform(m, v):
	r = len(m); c = len(v)
	p = []
	for i in range(r):
		s = 0
		for j in range(c):
			s += m[i][j]*v[j]
		p.append(s)
	return(p)
	
def string(m):
	s = "["
	r = len(m)
	for i in range(r):
		s += VectorUtils.string(m[i]) + "\n"
	s += "]"
	return(s)
	
def transpose(m):
	M = []
	# M[j][i] = m[i][j]
	for j in range(len(m[0])):
		r = []
		for i in range(len(m)):
			r.append(m[i][j])
		M.append(r)
	return(M)

def det3x3(a):
	return(a[0][0]*a[1][1]*a[2][2] + a[0][1]*a[1][2]*a[2][0]+a[0][2]*a[1][0]*a[2][1]
	-a[2][0]*a[1][1]*a[0][2]-a[0][0]*a[2][1]*a[1][2]-a[1][0]*a[0][1]*a[2][2])

def inverse3x3(a):
	d = float(det3x3(a))
	print "det = " + str(d)
	b00 = (a[1][1]*a[2][2]-a[2][1]*a[1][2])
	b01 = (a[1][0]*a[2][2]-a[2][0]*a[1][2])
	b02 = (a[1][0]*a[2][1]-a[2][0]*a[1][1])

	b10 = (a[0][1]*a[2][2]-a[2][1]*a[0][2])
	b11 = (a[0][0]*a[2][2]-a[2][0]*a[0][2])
	b12 = (a[0][0]*a[2][1]-a[2][0]*a[0][1])

	b20 = (a[0][1]*a[0][2]-a[1][1]*a[0][2])
	b21 = (a[0][0]*a[1][2]-a[1][0]*a[0][2])
	b22 = (a[0][0]*a[1][1]-a[1][0]*a[0][1])

	B = [
		[ b00/d, -b10/d,  b20/d],
		[-b01/d,  b11/d, -b21/d],
		[ b02/d, -b12/d,  b22/d]
	]
	return B



